indexing

   description: "Test POSIX system class."

   author: "Berend de Boer"
   date: "$Date: 2001/12/27 $"
   revision: "$Revision: #1 $"


class TEST_P_SYSTEM

inherit
   
   POSIX_SYSTEM

creation
   
   make
   
feature

   make is
      do
         print ("Begin test system.%N")         

         print ("sysname      : ")
         print (system_name)
         print (".%N")
         print ("nodename     : ")
         print (node_name)
         print (".%N")
         print ("release      : ")
         print (release)
         print (".%N")
         print ("version      : ")
         print (version)
         print (".%N")
         print ("machine      : ")
         print (machine)
         print (".%N%N")

         print ("arg_max      : ")
         print (arg_max)
         print (".%N")
         print ("child_max    : ")
         print (child_max)
         print (".%N")
         print ("clock_ticks  : ")
         print (clock_ticks)
         print (".%N")
         print ("max_input    : ")
         print (MAX_INPUT)
         print (".%N")
         print ("name_max     : ")
         print (NAME_MAX)
         print (".%N")
         print ("ngroups_max  : ")
         print (ngroups_max)
         print (".%N")
         print ("open_max     : ")
         print (open_max)
         print (".%N")
         print ("page_size    : ")
         print (page_size)
         print (".%N")
         print ("path_max     : ")
         print (PATH_MAX)
         print (".%N")
         print ("pipe_buf     : ")
         print (PIPE_BUF)
         print (".%N")
         print ("stream_max   : ")
         print (stream_max)
         print (".%N")
         print ("ssize_max    : ")
         print (SSIZE_MAX)
         print (".%N")
         print ("tzname_max   : ")
         print (tzname_max)
         print (".%N")
         print ("job_control  : ")
         print (has_job_control)
         print (".%N")
         print ("saved_ids    : ")
         print (has_saved_ids)
         print (".%N")
         print ("posix_version: ")
         print (posix_version)
         print (".%N")

         print_supports (supports_asynchronous_io, "Asynchronous io")
         print_supports (supports_file_synchronization, "File synchronization")
         print_supports (supports_memory_mapped_files, "Memory mapped files")
         print_supports (supports_memory_locking, "Memory locking")
         print_supports (supports_memlock_range, "Memory range locking")
         print_supports (supports_memory_protection, "Memory protection")
         print_supports (supports_message_passing, "Message passing")
         print_supports (supports_priority_scheduling, "Priority scheduling")
         print_supports (supports_semaphores, "Semaphores")
         print_supports (supports_shared_memory_objects, "Shared memory objects")
         print_supports (supports_synchronized_io, "Synchronous io")
         print_supports (supports_timers, "Timers")
         print_supports (supports_threads, "Threads")

         print ("End test system.%N")         
      end


   print_supports (supported: BOOLEAN; what: STRING) is
      do
         if not supported then
            print ("!! ")
         end
         print (what)
         if not supported then
            print (" not") 
         end
         print (" supported.%N")
      end
   
end -- class TEST_P_SYSTEM
